package com.bpcl.lpg.core.jalo;

import java.util.Collections;
import java.util.HashMap;
import com.bpcl.lpg.core.constants.GeneratedBpcllpgcoreConstants;
import de.hybris.platform.jalo.enumeration.EnumerationValue;
import de.hybris.platform.jalo.JaloBusinessException;
import de.hybris.platform.jalo.type.ComposedType;
import java.util.Date;
import de.hybris.platform.jalo.ExtensibleItem;
import de.hybris.platform.jalo.JaloInvalidParameterException;
import de.hybris.platform.jalo.SessionContext;
import de.hybris.platform.jalo.Item;
import java.util.Map;
import de.hybris.platform.util.BidirectionalOneToManyHandler;
import de.hybris.platform.directpersistence.annotation.SLDSafe;
import de.hybris.platform.jalo.GenericItem;

@SLDSafe
public class CODRefills extends GenericItem
{
    public static final String CONSUMERID = "consumerId";
    public static final String BOOKDATE = "bookDate";
    public static final String ORDERNO = "orderNo";
    public static final String DESCRIPTION = "description";
    public static final String STATUS = "status";
    public static final String QUANTITY = "quantity";
    public static final String BPCLREFERENCEID = "bpclReferenceId";
    public static final String DISTCODE = "distCode";
    public static final String PRODUCTCODE = "productCode";
    public static final String AMOUNT = "amount";
    public static final String ACCOUNT = "account";
    protected static final BidirectionalOneToManyHandler<CODRefills> ACCOUNTHANDLER;
    protected static final Map<String, Item.AttributeMode> DEFAULT_INITIAL_ATTRIBUTES;
    
    protected Map<String, Item.AttributeMode> getDefaultAttributeModes() {
        return CODRefills.DEFAULT_INITIAL_ATTRIBUTES;
    }
    
    public LPGConnection getAccount(final SessionContext ctx) {
        return (LPGConnection)this.getProperty(ctx, "account".intern());
    }
    
    public LPGConnection getAccount() {
        return this.getAccount(this.getSession().getSessionContext());
    }
    
    protected void setAccount(final SessionContext ctx, final LPGConnection value) {
        if (ctx == null) {
            throw new JaloInvalidParameterException("ctx is null", 0);
        }
        if (ctx.getAttribute("core.types.creation.initial") != Boolean.TRUE) {
            throw new JaloInvalidParameterException("attribute '" + "account".intern() + "' is not changeable", 0);
        }
        CODRefills.ACCOUNTHANDLER.addValue(ctx, (Item)value, (ExtensibleItem)this);
    }
    
    protected void setAccount(final LPGConnection value) {
        this.setAccount(this.getSession().getSessionContext(), value);
    }
    
    public Double getAmount(final SessionContext ctx) {
        return (Double)this.getProperty(ctx, "amount".intern());
    }
    
    public Double getAmount() {
        return this.getAmount(this.getSession().getSessionContext());
    }
    
    public double getAmountAsPrimitive(final SessionContext ctx) {
        final Double value = this.getAmount(ctx);
        return (value != null) ? value : 0.0;
    }
    
    public double getAmountAsPrimitive() {
        return this.getAmountAsPrimitive(this.getSession().getSessionContext());
    }
    
    public void setAmount(final SessionContext ctx, final Double value) {
        this.setProperty(ctx, "amount".intern(), (Object)value);
    }
    
    public void setAmount(final Double value) {
        this.setAmount(this.getSession().getSessionContext(), value);
    }
    
    public void setAmount(final SessionContext ctx, final double value) {
        this.setAmount(ctx, Double.valueOf(value));
    }
    
    public void setAmount(final double value) {
        this.setAmount(this.getSession().getSessionContext(), value);
    }
    
    public Date getBookDate(final SessionContext ctx) {
        return (Date)this.getProperty(ctx, "bookDate".intern());
    }
    
    public Date getBookDate() {
        return this.getBookDate(this.getSession().getSessionContext());
    }
    
    public void setBookDate(final SessionContext ctx, final Date value) {
        this.setProperty(ctx, "bookDate".intern(), (Object)value);
    }
    
    public void setBookDate(final Date value) {
        this.setBookDate(this.getSession().getSessionContext(), value);
    }
    
    public String getBpclReferenceId(final SessionContext ctx) {
        return (String)this.getProperty(ctx, "bpclReferenceId".intern());
    }
    
    public String getBpclReferenceId() {
        return this.getBpclReferenceId(this.getSession().getSessionContext());
    }
    
    public void setBpclReferenceId(final SessionContext ctx, final String value) {
        this.setProperty(ctx, "bpclReferenceId".intern(), (Object)value);
    }
    
    public void setBpclReferenceId(final String value) {
        this.setBpclReferenceId(this.getSession().getSessionContext(), value);
    }
    
    public String getConsumerId(final SessionContext ctx) {
        return (String)this.getProperty(ctx, "consumerId".intern());
    }
    
    public String getConsumerId() {
        return this.getConsumerId(this.getSession().getSessionContext());
    }
    
    public void setConsumerId(final SessionContext ctx, final String value) {
        this.setProperty(ctx, "consumerId".intern(), (Object)value);
    }
    
    public void setConsumerId(final String value) {
        this.setConsumerId(this.getSession().getSessionContext(), value);
    }
    
    protected Item createItem(final SessionContext ctx, final ComposedType type, final Item.ItemAttributeMap allAttributes) throws JaloBusinessException {
        CODRefills.ACCOUNTHANDLER.newInstance(ctx, allAttributes);
        return super.createItem(ctx, type, allAttributes);
    }
    
    public String getDescription(final SessionContext ctx) {
        return (String)this.getProperty(ctx, "description".intern());
    }
    
    public String getDescription() {
        return this.getDescription(this.getSession().getSessionContext());
    }
    
    public void setDescription(final SessionContext ctx, final String value) {
        this.setProperty(ctx, "description".intern(), (Object)value);
    }
    
    public void setDescription(final String value) {
        this.setDescription(this.getSession().getSessionContext(), value);
    }
    
    public String getDistCode(final SessionContext ctx) {
        return (String)this.getProperty(ctx, "distCode".intern());
    }
    
    public String getDistCode() {
        return this.getDistCode(this.getSession().getSessionContext());
    }
    
    public void setDistCode(final SessionContext ctx, final String value) {
        this.setProperty(ctx, "distCode".intern(), (Object)value);
    }
    
    public void setDistCode(final String value) {
        this.setDistCode(this.getSession().getSessionContext(), value);
    }
    
    public String getOrderNo(final SessionContext ctx) {
        return (String)this.getProperty(ctx, "orderNo".intern());
    }
    
    public String getOrderNo() {
        return this.getOrderNo(this.getSession().getSessionContext());
    }
    
    public void setOrderNo(final SessionContext ctx, final String value) {
        this.setProperty(ctx, "orderNo".intern(), (Object)value);
    }
    
    public void setOrderNo(final String value) {
        this.setOrderNo(this.getSession().getSessionContext(), value);
    }
    
    public String getProductCode(final SessionContext ctx) {
        return (String)this.getProperty(ctx, "productCode".intern());
    }
    
    public String getProductCode() {
        return this.getProductCode(this.getSession().getSessionContext());
    }
    
    public void setProductCode(final SessionContext ctx, final String value) {
        this.setProperty(ctx, "productCode".intern(), (Object)value);
    }
    
    public void setProductCode(final String value) {
        this.setProductCode(this.getSession().getSessionContext(), value);
    }
    
    public Integer getQuantity(final SessionContext ctx) {
        return (Integer)this.getProperty(ctx, "quantity".intern());
    }
    
    public Integer getQuantity() {
        return this.getQuantity(this.getSession().getSessionContext());
    }
    
    public int getQuantityAsPrimitive(final SessionContext ctx) {
        final Integer value = this.getQuantity(ctx);
        return (value != null) ? value : 0;
    }
    
    public int getQuantityAsPrimitive() {
        return this.getQuantityAsPrimitive(this.getSession().getSessionContext());
    }
    
    public void setQuantity(final SessionContext ctx, final Integer value) {
        this.setProperty(ctx, "quantity".intern(), (Object)value);
    }
    
    public void setQuantity(final Integer value) {
        this.setQuantity(this.getSession().getSessionContext(), value);
    }
    
    public void setQuantity(final SessionContext ctx, final int value) {
        this.setQuantity(ctx, Integer.valueOf(value));
    }
    
    public void setQuantity(final int value) {
        this.setQuantity(this.getSession().getSessionContext(), value);
    }
    
    public EnumerationValue getStatus(final SessionContext ctx) {
        return (EnumerationValue)this.getProperty(ctx, "status".intern());
    }
    
    public EnumerationValue getStatus() {
        return this.getStatus(this.getSession().getSessionContext());
    }
    
    public void setStatus(final SessionContext ctx, final EnumerationValue value) {
        this.setProperty(ctx, "status".intern(), (Object)value);
    }
    
    public void setStatus(final EnumerationValue value) {
        this.setStatus(this.getSession().getSessionContext(), value);
    }
    
    static {
        ACCOUNTHANDLER = new BidirectionalOneToManyHandler(GeneratedBpcllpgcoreConstants.TC.CODREFILLS, false, "account", (String)null, false, true, 0);
        final Map<String, Item.AttributeMode> tmp = new HashMap<String, Item.AttributeMode>();
        tmp.put("consumerId", Item.AttributeMode.INITIAL);
        tmp.put("bookDate", Item.AttributeMode.INITIAL);
        tmp.put("orderNo", Item.AttributeMode.INITIAL);
        tmp.put("description", Item.AttributeMode.INITIAL);
        tmp.put("status", Item.AttributeMode.INITIAL);
        tmp.put("quantity", Item.AttributeMode.INITIAL);
        tmp.put("bpclReferenceId", Item.AttributeMode.INITIAL);
        tmp.put("distCode", Item.AttributeMode.INITIAL);
        tmp.put("productCode", Item.AttributeMode.INITIAL);
        tmp.put("amount", Item.AttributeMode.INITIAL);
        tmp.put("account", Item.AttributeMode.INITIAL);
        DEFAULT_INITIAL_ATTRIBUTES = Collections.unmodifiableMap((Map<? extends String, ? extends Item.AttributeMode>)tmp);
    }
}
